import { PartialObserver, Unsubscribable } from '../types';
import { Data } from './internal';
export declare class Cell<T> {
    protected internal: Data<T>;
    static of<T>(initial: T): Cell<T>;
    constructor(internal: Data<T>);
    get value(): T;
    get error(): any;
    /**
     * @deprecated Should be only used for interop.
     */
    subscribe(observer?: PartialObserver<T>): CellSubscription<T>;
    /**
     * @deprecated Should be only used for interop.
     */
    subscribe(next?: (value: T) => void, error?: (error: any) => void, complete?: () => void): CellSubscription<T>;
}
declare class CellSubscription<T> implements Unsubscribable {
    private readonly reaction;
    constructor(cell: Cell<T>, observer: PartialObserver<T>);
    unsubscribe(): void;
}
export declare class Reaction {
    private internal;
    constructor(callback: () => void);
    execute<T>(expr: () => T): NonNullable<T>;
    dispose(): void;
}
export declare function mutable<T>(initialValue: T): [
    Cell<T>,
    (value: (T extends Function ? never : T) | ((current: T) => T)) => void
];
export declare function mutValue<T>(initialValue: T): [Cell<T>, (value: T) => void];
export declare function computed<T>(expr: () => T): Cell<T>;
export {};
