import { Action, Cleanable } from '../types';
export declare type TaskYieldable<T> = (resolve: Action<T>, reject: Action<any>) => Cleanable;
export declare type Runnable<T> = {
    [Symbol.iterator](): RunnableGenerator<T>;
};
export declare type AsyncRunnable<T> = {
    [Symbol.asyncIterator](): AsyncRunnableGenerator<T>;
};
export declare type RunnableGenerator<T> = Generator<TaskYieldable<any>, T, any>;
export declare type AsyncRunnableGenerator<T> = AsyncGenerator<TaskYieldable<any>, T, any>;
export interface ReadableChannel<T> {
    next(): Runnable<T>;
    hasNext(): Runnable<boolean>;
}
